#include <stdio.h>
#include <fcntl.h>

int main( argc, argv )
int argc;
char *argv[];
{

char hdr1[ 20 ] = { 0x2a, 0x2a, 0x54, 0x49,  0x39, 0x32, 0x50, 0x2a,
                    0x01, 0x00, 0x6d, 0x61,  0x69, 0x6e, 0x00, 0x00,
                    0x00, 0x00, 0x00, 0x00 };

char hdr2[ 6 ]  = { 0x01, 0x00, 0x52, 0x00, 0x00, 0x00 }; 

unsigned int i;
unsigned int j;
unsigned long length;

char filename[1024];
char outfilename[1024];

char linebuf[1024];
int  linelen;

unsigned char buf[128];
unsigned char *inbuf;
unsigned char *txtbuf;

char *ip;
char *op;

char ckbuf[128];
unsigned short checksum;

int          writelen;
int          readlen;

unsigned int inlen;
unsigned int txtlen;

unsigned int outfilesize;

int  infd;
int  outfd;

int  invert;

unsigned int  a,b;

/*----------------------------------------*/


if ( argc == 2 )
{
   invert = 0;
   strcpy( filename, argv[1] );
}
else if ( argc == 3 && strcmp(argv[1],"-d") == 0)
{
   strcpy( filename, argv[2] );
   strcpy( outfilename, argv[2] );
   strcat( filename, ".89t" );
   invert = 1;
}
else
{
   printf("Usage: txt289 [-d] <filename>\n");
   exit(1);
}


infd = open( filename, O_RDONLY | O_BINARY );
if ( infd < 0 )
{
   printf("error: unable to open file path %s\n",filename);
   exit(1);
}

inlen = lseek( infd, 0, SEEK_END );

printf("inlen = %d\n",inlen);


inbuf = (char *) malloc( inlen+20 );
if ( inbuf == NULL )
{
   printf("error: unable to malloc %d bytes\n",inlen);
   exit(1);
}

lseek( infd, 0, SEEK_SET );
readlen = read( infd, inbuf, inlen );
if ( readlen != inlen )
{
  printf("error reading input file %s\n",filename);
  exit(1);
}

if ( invert == 1 )  /* -d option */
{
    outfd = open( outfilename,
                  O_CREAT | O_TRUNC | O_BINARY | O_RDWR,
                  0660 );
    if ( outfd < 0 )
    {
       printf("error: unable to open file path %s\n",filename);
       exit(1);
    }

    /*-----------------------------------*/
    /* text data is from inbuf+0x5a      */
    /* up to and include byte before     */
    /* inbuf+0x5a+big_endian_word(0x58)  */
    /*-----------------------------------*/

    length = (unsigned int) (inbuf[0x56]<<8)
               + (unsigned int ) inbuf[0x57] - 4;

#if 0
    a = inbuf[0x58];
    b = inbuf[0x59];
    printf("a=%x, b=%x\n",a,b);
    length = (a<<8)) + b;  /* PARENS ARE NEEDED !!! */
#endif


    inbuf[ 0x5a+length ] = 0;

    ip = &inbuf[ 0x5a ];

    linelen = 0;
    op = linebuf;
    if ( *ip == 0x20 )
       ip++;
 
    for (;;)
    {

        if ( *ip ==  0x0d || *ip == 0 )
        {
           *op++ = 0x0d; /* remove for unix */
           linelen++;

           *op++ = 0x0a;
           linelen++;

           write( outfd, linebuf, linelen );

           if ( *ip == 0 )
              break;

           linelen = 0;
           op = linebuf;

           ip++; /* after 0x0d */
           if ( *ip == 0x20 )
              ip++;
           continue;

        }
        *op++ = *ip++;
        linelen++;
    }

    close( infd );
    close( outfd );
    exit(0);
}


/*--------------------------------------*/
/* now convert lines to ti89 format     */
/* wherein every line starts with 0x20  */
/* and ends with only a 0x0d            */
/* inbuf: dos: 2(crlf)/line unix: 1(lf) */
/* assume a max of 5000 lines.          */
/* I could count but am too lazy.       */
/*--------------------------------------*/


txtbuf = (char *) malloc( inlen+5000 );
if ( txtbuf == NULL )
{
   printf("error: unable to malloc %d bytes\n",inlen);
   exit(1);
}

txtlen = 0;
inbuf[inlen] = 0;
ip = inbuf;
op = txtbuf;

for(;;)
{
    *op++ = 32;  /* space */
    txtlen++;
    for(;;)
    {
       if ( *ip == 0 )
          break;

       if ( *ip == 10 || *ip == 13 )  
       {
          *op++ = 13;
          if ( *ip == 13 && *(ip+1) == 10  && *(ip+2) == 0 )
          {
             break;
          }
          if ( *ip == 13 && *(ip+1) == 10 )
          {
             ip++;
          }
          if ( *ip == 10 && *(ip+1) == 13 )
          {
             ip++;
          }
          txtlen++;
          break;
       }
       *op++ = *ip++;
       txtlen++;
    }
    if ( *ip == 13 && *(ip+1) == 10  && *(ip+2) == 0 )
    {
       *op++ = 32;   // NEW
       txtlen++;
       break;
    }
    if ( *ip == 0 )
    {
       *op++ = 32;   // NEW
       txtlen++;
       break;
    }
    ip++;
}

/*--------------------------------*/
/* now we have correct txt format */
/* in txtbuf, with length txtlen  */
/*--------------------------------*/

strcpy( outfilename, filename );
strcat( outfilename, ".89t" );
outfd = open( outfilename, O_CREAT | O_TRUNC | O_BINARY | O_RDWR, 0660 );
if ( outfd < 0 )
{
   printf("error: unable to open file path %s\n",filename);
   exit(1);
}

memcpy( &buf[ 0x0  ],  hdr1, 20 );
memset( &buf[ 0x14 ],  0,    38 );
memcpy( &buf[ 0x3a ],  hdr2,  6 );

memset( &buf[ 0x40 ],  0,  8 );
strcpy( &buf[0x40], filename );   /* max 8 including null */

memset( &buf[ 0x48 ],  0, 14 );

buf[ 0x48 ] = 0x0b;
buf[ 0x4a ] = 0x00;

outfilesize = txtlen + 0x5e;
buf[ 0x4c ] = outfilesize & 0x00ff;
buf[ 0x4d ] =  (outfilesize & 0xff00) >> 8;

buf[ 0x50 ] = 0xa5;
buf[ 0x51 ] = 0x5a;

buf[ 0x56 ] = ( (txtlen+4) & 0xff00) >> 8;
buf[ 0x57 ] = (txtlen+4) & 0x00ff;

#if 0
buf[ 0x58 ] = (txtlen & 0xff00) >> 8;
buf[ 0x59 ] = (txtlen) & 0x00ff;
#endif
#if 1
buf[ 0x58 ] = 0;
buf[ 0x59 ] = 1;
#endif

writelen = write( outfd, buf, 0x5a );
if ( writelen != 0x5a )
{
  printf("error writing 0x5a bytes to output file %s\n",filename);
  exit(1);
}

writelen = write( outfd, txtbuf, txtlen );
if ( writelen != txtlen )
{
  printf("error writing txt %d bytes to output file %s\n",txtlen,filename);
  exit(1);
}

checksum = 0;
checksum += buf[ 0x56 ];
checksum += buf[ 0x57 ];
checksum += buf[ 0x58 ];
checksum += buf[ 0x59 ];

for (i=0;i<txtlen;i++)
{
   checksum += txtbuf[i];
}
checksum += 0x00e0;

ckbuf[0] = 0x00;
ckbuf[1] = 0xe0;
ckbuf[2] = (checksum  & 0x00ff);
ckbuf[3] = (checksum  & 0xff00) >> 8;

writelen = write( outfd, ckbuf, 4 );
if ( writelen != 4 )
{
  printf("error writing 4 bytes to output file %s\n",filename);
  exit(1);
}

close( outfd );
close( infd );

}
